﻿Imports System.Drawing.Imaging
Imports System.Drawing.Drawing2D

Public Class Form1
    ' Draw the initial image.
    Private Sub Form1_Load() Handles MyBase.Load
        DrawDiamond()
    End Sub

    ' Draw the an image with the new size.
    Private Sub Form1_Resize() Handles MyBase.Resize
        DrawDiamond()
    End Sub

    Private Sub DrawDiamond()
        ' Get the drawing surface's size.
        Dim wid As Integer = picCanvas.ClientSize.Width
        Dim hgt As Integer = picCanvas.ClientSize.Height

        ' Do nothing if we have no size.
        ' This happens, for example, if the form is minimized.
        If wid < 1 Or hgt < 1 Then Exit Sub

        ' Make a Bitmap and Graphics to fit.
        Dim bm As New Bitmap(wid, hgt)
        Using gr As Graphics = Graphics.FromImage(bm)
            ' Fill the drawing area with a hatch pattern.
            Using bg_brush As New HatchBrush(HatchStyle.HorizontalBrick,
                Color.Blue, Color.Aqua)
                gr.FillRectangle(bg_brush, picCanvas.ClientRectangle)
            End Using ' bg_brush

            ' Draw a dimond.
            Dim pts() As Point = {
                New Point(wid \ 2, 0),
                New Point(wid, hgt \ 2),
                New Point(wid \ 2, hgt),
                New Point(0, hgt \ 2)
            }
            gr.FillPolygon(Brushes.White, pts)
            gr.DrawPolygon(Pens.Black, pts)

            ' Display the result.
            picCanvas.Image = bm
        End Using ' gr
    End Sub
End Class
